package org.rcisoft.business.opmArticle.dao;


import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.ibatis.annotations.Param;
import org.rcisoft.business.opmArticle.entity.ArticleCommentDTO;
import org.rcisoft.business.opmArticle.entity.ArticleCommentVO;
import org.rcisoft.business.opmArticle.entity.LikeDTO;
import org.rcisoft.business.opmArticle.entity.OpmArticle;
import org.rcisoft.core.mapper.CyBaseMapper;
import org.rcisoft.core.model.CyPageInfo;

import javax.persistence.criteria.CriteriaBuilder;
import java.util.List;


/**
* Created with cy on 2024年3月30日 下午1:51:15.
*/

public interface OpmArticleRepository extends CyBaseMapper<OpmArticle> {


    List<OpmArticle> queryOpmArticle(@Param("entity") OpmArticle cmsBanner);

    /**
    * 分页查询 OpmArticle
    *
    */
    IPage<OpmArticle> queryOpmArticlePaged(CyPageInfo cyPageInfo, @Param("entity") OpmArticle opmArticle);


    OpmArticle selectArticleDetail(@Param("articleId") Integer articleId, @Param("loginUserId") String loginUserId);

    //查询评论
    List<ArticleCommentVO> selectArticleComment(@Param("articleId") Integer articleId);

    //查询评论下的子评论
    List<ArticleCommentVO> selectArticleChildrenComment(@Param("articleId") Integer articleId, @Param("parentId") Integer parentId);

    //删除评论
    int deleteComment(OpmArticle opmArticle);

    //添加点赞记录
    int likeAdd(@Param("entity") LikeDTO likeDTO);

    //删除点赞记录
    int likeDelete(@Param("userId") String userId,@Param("articleId") Integer articleId);

    //点赞数+1
    int addLikeCount(Integer articleId);

    //点赞数-1
    int reduceLikeCount(Integer articleId);

    //动态表评论数+1
    int addArticleCommentCount(Integer articleId);

    //评论表评论数+1
    int addCommentCount(Integer commentId);

    //添加动态评论
    int addComment(@Param("entity") ArticleCommentDTO dto);
}

